
/* log_mfa_init.c */

int perturb(/*int limit*/);
double *init_spin_matrix2(/*int num_vertices, char *fname*/);
double **init_spin_matrix(/*int num_vertices*/);
int rnd(/*int low, int high*/);
int lrnd(/*int low, int high*/);
double *init_pcg(/*void*/);
void update_spin(/*int i, double **spin, double spin_new*/);


/* log_mfa_io.c */

FILE *open_file(/*char *fname, int mode*/);
int read_max_vertices(/*struct _iobuf *fp*/);
int read_graph(/*struct _iobuf *fp, vertex_t *vertex, int max_vertices*/);
void read_vrtx_info(/*struct _iobuf *fp, int i, vertex_t *vertex*/);
int *generate_solution(/*double **spin, int num_vertices*/);
void find_solution_quality(/*int *map, int num_vertices, vertex_t *vertex*/);
double *find_max(/*double *spin, int num_vertices*/);
int maxdouble(/*double *p1, double *p2, int size*/);


/* log_mfa_main.c */

int main(/*int argc, char **argv*/);
void printv(/*vertex_t *vertex, int i*/);
int *dec2bin(/*int dec, int numOfbits*/);


/* log_mfa_vectop.c */

double **eval_lambda(/*int num_vertices, vertex_t *vertex, double **spin*/);
double eval_coeff_R(/*int num_vertices, double *lambda, double *spin, vertex_t *vertex*/);
int addf(/*double *p1, double *p2, int size*/);
double eval_psi(/*int mynode, int i, double **spin, vertex_t *vertex, int
num_vertices*/);
double *eval_mean_field(/*int element, double *lambda_i, double R, double **spin, vertex_t *vertex, int num_vertices*/);
double *eval_abc(/*double mean_field, double temp, double spin_ip*/);
