#include <stdio.h>
/*#include "/usr/local/express/include/express.h"*/
#include "smfa.h"
#include "decl.h"

#define  mm    2147483647
#define  DEBUG    0

/*#######################################################################*/

int perturb( limit )
int limit;
{

	int rnd_element;

	rnd_element = rnd(0, limit-1);

	return rnd_element;

}


double **init_spin_matrix( num_vertices)
int num_vertices;
{
	double **spin;
	int i, j, type6 = 36;

    spin = (double **)calloc(num_vertices, sizeof(double *));

	if ( spin == NULL )
	    exit(10);   /* Out Of memory Condition */

    for ( i=0; i < num_vertices; i++)
        if ( (spin[i] = MEM(double,NPROC)) == NULL)
            exit(10);   /* Out Of memory Condition */

    for ( j=0; j < NPROC; j++) {
        seedval = num_vertices * j;
        srand48( seedval );
        for ( i=0; i < num_vertices; i++) {
            spin[i][j] = (double)drand48();
            spin[i][j] = 1-spin[i][j]*2;     /* Initializing from -1 to +1 */
		}
	}

	return spin;
}

int rnd(low,high)
int low, high;
{
    double drand48();
    double f;
    int rnd_no;

    f = (double) drand48();
    rnd_no = (int)((1-f)*(low-1) + 1 + f*high);
    return rnd_no;
} /*--------------------------------------------------------------------*/



 
int lrnd(low,high)
int low, high;
{
    long lrand48();
    double f;
    int rnd_no;

    f = (double) lrand48() / mm;
    rnd_no = (1-f)*low + f*high;
    return rnd_no;
}


double *init_pcg()
{
	double *pcg;
	int i;
    int nproc;

	nproc = NPROC;

	pcg    = MEM(double, nproc);

	if ( pcg == NULL) {
		fprintf(stderr, "\n Out Of memory in init_pcg()\n");
	}


	for ( i=0; i < NPROC; i++)
		pcg[i] = 1.0;

	return pcg;
}

void update_spin( i, spin, spin_new)
int i;
double **spin;
double *spin_new;
{

    int j;

    for(j =0; j < NPROC; j++)
        spin[i][j] = spin_new[j];

}
